package edu.mermet.tp8;

import java.util.*;
import java.nio.file.*;
import java.io.*;


public class Preferences {

	private static Preferences pref;
	private static Properties propri;
	private static String env, rIhm, rPref;

	private Preferences(){
		propri = new Properties();
		env = System.getProperty("user.home");
		rIhm = env+"/.ihm";
		rPref = rIhm+"/preferences.xml";
	}

	public static Preferences getPreferences(){
		try{
			if(Preferences.pref == null){
				Preferences.pref = new Preferences();
				if(!Files.isDirectory(Paths.get(rIhm))){
					Files.createDirectory(Paths.get(rIhm));
				}
				if(! Files.exists(Paths.get(rPref ))){
					initPreferences();
				}
				Preferences.propri.loadFromXML(new FileInputStream(rPref));
			}
		}
		catch(Exception e){e.printStackTrace();}
		return Preferences.pref;
	}

	public void savePreference(){
		try{
			Preferences.propri.storeToXML(new FileOutputStream(rIhm), null);
		}catch(Exception e){e.printStackTrace();}
	}

	private static void initPreferences(){
		try{
			Preferences.propri.setProperty("Conversion", "auto");
			Preferences.propri.setProperty("Texte", "auto");
			Preferences.propri.setProperty("Diapo", "auto");
			Preferences.propri.setProperty("Boutons", "auto");

			Preferences.propri.storeToXML(new FileOutputStream(rPref), null);
		}catch(Exception e){e.printStackTrace();}
	}



	public String getPreferencePerType(String type){
		return Preferences.propri.getProperty(type);
	}


	public void setPreference(String type, String pref){
		Preferences.propri.setProperty(type, pref);

	}

}