package edu.mermet.tp8.fenetres;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import edu.mermet.tp8.Application;

public class JDialogCommentFaire extends JDialog 
{


    Application application;
    HashMap <String,String> contenu;
    EcouteurJDialogCommentFaire ecJD;
    JList jlTitre;
    JEditorPane jeTexte;
    JSplitPane pane;
    ResourceBundle bundleTitre,bundleTexte;
    String[] arrayTitre;

    public JDialogCommentFaire(Application application){
        super(application, "Comment Faire ?", false);
        this.application = application;
        init();
    }

    private void init(){

        
        jeTexte = new JEditorPane();
        jeTexte.setContentType("text/html");

        Dimension minimumSize = new Dimension(200, 200);
        this.setMinimumSize(minimumSize);
        setLocationRelativeTo(null);

        ecJD = new EcouteurJDialogCommentFaire();
        addWindowListener(ecJD);

        bundleTitre = ResourceBundle.getBundle("HowTo.titres");
        bundleTexte = ResourceBundle.getBundle("HowTo.textes");

        arrayTitre = new String[Collections.list(bundleTitre.getKeys()).size()];
        int i =0;
        Enumeration<String> enumKey = bundleTitre.getKeys();
        while(enumKey.hasMoreElements()){  
            String titre = bundleTitre.getString(enumKey.nextElement());
            arrayTitre[i] = titre;
        }

        jlTitre = new JList(arrayTitre);
        jlTitre.addMouseListener(new EcouteurCliqueJList());

        pane = new JSplitPane(SwingConstants.VERTICAL, jlTitre, jeTexte);
        add(pane);
        


    }

    class EcouteurJDialogCommentFaire extends WindowAdapter{

        public void windowClosing(WindowEvent e){
            application.enableCommentFaire(true);
        }
    }

    class EcouteurCliqueJList implements MouseListener
    {
        @Override
        public void mouseClicked(MouseEvent e) {
            String valClicked = jlTitre.getSelectedValue().toString();
            String key = "";

            Enumeration<String> enumKeyAction = bundleTitre.getKeys();
            while(enumKeyAction.hasMoreElements() && key.equals("")){  
                String cle = enumKeyAction.nextElement();
                String titre = bundleTitre.getString(cle);
                if(titre.equals(valClicked))
                    key = cle;
            }
            jeTexte.setText(bundleTexte.getString(key));

            }

        

        @Override
        public void mouseExited(MouseEvent e){}
        @Override
        public void mouseEntered(MouseEvent e){}
        @Override
        public void mouseReleased(MouseEvent e){}
        @Override
        public void mousePressed(MouseEvent e){}
    }
}