package edu.mermet.tp8.fenetres;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import edu.mermet.tp8.*;
import java.util.*;

public class JDialogConfigurationMenu extends JDialog 
{
    Application application;
    EcouteurJDialogConfigurationMenu ecJD;
    JLabel jlConv, jlTexte,jlDiapo,jlBoutons;
    ButtonGroup  jgConv, jgTexte,jgDiapo,jgBoutons; 
    JRadioButton jrbConvAuto, jrbConvAff,jrbConvCache;
    JRadioButton jrbTexteAuto, jrbTexteAff,jrbTexteCache;
    JRadioButton jrbDiapoAuto, jrbDiapoAff,jrbDiapoCache;
    JRadioButton jrbBoutonsAuto, jrbBoutonsAff,jrbBoutonsCache;
    JButton jbAnnuler, jbValider;

    HashMap<String,ButtonGroup> hmbg;
    Preferences pref;

    public JDialogConfigurationMenu(Application application){
        super(application, "Configuration Menu", false);
        this.application = application;
        init();
    }

    private void init(){

        pref = Preferences.getPreferences();
        setSize(800,400);
        setLayout(new BorderLayout());
        JPanel pHaut = new JPanel();
        JPanel pBas = new JPanel();
        pHaut.setLayout(new GridLayout(4,4));
        pBas.setLayout(new FlowLayout());
        hmbg = new  HashMap<String,ButtonGroup>();

        jlConv = new JLabel("Conversion Celsius/Farenheit");
        jgConv = new ButtonGroup();
        hmbg.put("Conversion",jgConv);
        jrbConvAuto = new JRadioButton("Auto",pref.getPreferencePerType("Conversion").equals("auto"));
        jrbConvAff = new JRadioButton("Affiché",pref.getPreferencePerType("Conversion").equals("affiche"));
        jrbConvCache = new JRadioButton("Caché",pref.getPreferencePerType("Conversion").equals("cache"));

        jlTexte = new JLabel("Saisie de Texte");
        jgTexte = new ButtonGroup();
        hmbg.put("Texte",jgTexte);
        jrbTexteAuto = new JRadioButton("Auto",pref.getPreferencePerType("Texte").equals("auto"));
        jrbTexteAff = new JRadioButton("Affiché",pref.getPreferencePerType("Texte").equals("affiche"));
        jrbTexteCache = new JRadioButton("Caché",pref.getPreferencePerType("Texte").equals("cache"));

        jlDiapo = new JLabel("Diaporama");
        jgDiapo = new ButtonGroup();
        hmbg.put("Diapo",jgDiapo);
        jrbDiapoAuto = new JRadioButton("Auto",pref.getPreferencePerType("Diapo").equals("auto"));
        jrbDiapoAff = new JRadioButton("Affiché",pref.getPreferencePerType("Diapo").equals("affiche"));
        jrbDiapoCache = new JRadioButton("Caché",pref.getPreferencePerType("Diapo").equals("cache"));

        jlBoutons = new JLabel("Boutons");
        jgBoutons = new ButtonGroup();
        hmbg.put("Boutons",jgBoutons);
        jrbBoutonsAuto = new JRadioButton("Auto",pref.getPreferencePerType("Boutons").equals("auto"));
        jrbBoutonsAff = new JRadioButton("Affiché",pref.getPreferencePerType("Boutons").equals("affiche"));
        jrbBoutonsCache = new JRadioButton("Caché",pref.getPreferencePerType("Boutons").equals("cache"));

        jgConv.add(jrbConvAuto);
        jgConv.add(jrbConvAff);
        jgConv.add(jrbConvCache);

        jgTexte.add(jrbTexteAuto);
        jgTexte.add(jrbTexteAff);
        jgTexte.add(jrbTexteCache);

        jgDiapo.add(jrbDiapoAuto);
        jgDiapo.add(jrbDiapoAff);
        jgDiapo.add(jrbDiapoCache);

        jgBoutons.add(jrbBoutonsAuto);
        jgBoutons.add(jrbBoutonsAff);
        jgBoutons.add(jrbBoutonsCache);

        pHaut.add(jlConv);
        pHaut.add(jrbConvAuto);
        pHaut.add(jrbConvAff);
        pHaut.add(jrbConvCache);

        pHaut.add(jlTexte);
        pHaut.add(jrbTexteAuto);
        pHaut.add(jrbTexteAff);
        pHaut.add(jrbTexteCache);


        pHaut.add(jlDiapo);
        pHaut.add(jrbDiapoAuto);
        pHaut.add(jrbDiapoAff);
        pHaut.add(jrbDiapoCache);

        pHaut.add(jlBoutons);
        pHaut.add(jrbBoutonsAuto);
        pHaut.add(jrbBoutonsAff);
        pHaut.add(jrbBoutonsCache);

        Dimension minimumSize = new Dimension(200, 300);
        this.setMinimumSize(minimumSize);
        setLocationRelativeTo(null);
        ecJD = new EcouteurJDialogConfigurationMenu();
        addWindowListener(ecJD);

        add(pHaut, BorderLayout.CENTER);



        jbValider = new JButton("Valider");
        jbAnnuler = new JButton("Annuler");

        jbAnnuler.addActionListener(new EcouteurJButtonAnnuler(this));
        jbValider.addActionListener(new EcouteurJButtonValider(this));


        pBas.add(jbValider);
        pBas.add(jbAnnuler);



        add(pBas,BorderLayout.SOUTH);
        pack();

    }

    class EcouteurJDialogConfigurationMenu extends WindowAdapter{

        public void windowClosing(WindowEvent e){
            application.enableConfigurationMenu(true);
        }
    }

    class EcouteurJButtonAnnuler extends AbstractAction{

        JDialog jd;
        private EcouteurJButtonAnnuler(JDialog jd)
        {
            this.jd = jd;
        }
        public void actionPerformed(ActionEvent ae){
            application.enableConfigurationMenu(true);
            jd.dispose();
        }
    }

    class EcouteurJButtonValider extends AbstractAction{

        JDialog jd;
        private EcouteurJButtonValider(JDialog jd)
        {
            this.jd = jd;
        }

        public void actionPerformed(ActionEvent ae){
            HashMap<String, String> preference = new HashMap<String,String>();

            for( String key : hmbg.keySet())
            {
                ButtonGroup bg = hmbg.get(key);
              for (Enumeration<AbstractButton> buttons = bg.getElements(); buttons.hasMoreElements();) {
                AbstractButton button = buttons.nextElement();
                if (button.isSelected()) {
                    preference.put(key,button.getText());
                }
             }
            }


            for(String key : preference.keySet())
            {
                pref.setPreference(key,preference.get(key));
            }

            pref.savePreference();
            application.enableConfigurationMenu(true);
            jd.dispose();
        }

    }
}
